#include <stdio.h>
#include "stdtypes.h"

/****************************************************************************
 Objectives : transpose a 8 X 8 matrix
 Input      : a block to be transposed
 Output     : a transposed block
 Called By  : dct(), idct()
 Calls      : none
****************************************************************************/
long *transpose(block) 
long block[][8];
{
	long tmp[8][8];	/* temporary matrix */
	int   i, j;     /* index            */

	for (i=0; i<8; i++)
		for (j=0; j<8; j++)
			tmp[i][j] = block[j][i];
	for (i=0; i<8; i++)
		for (j=0; j<8; j++)
			block[i][j]=tmp[i][j];
	return (long *)block;
};


/****************************************************************************
 Objectives : matrix multiplication
 Input      : input matrices
 Output     : the result of matrix multiplication
 Called By  : dct(), idct()
 Calls      : none
****************************************************************************/
long *matrix_multiplication(n, m, dest)
long n[][8], m[][8], dest[][8];
{
	long 	tmp, i;     /* temporary storage */
	int	row, col;   /* index             */

	for(row=0; row<8; row++)
		for (col=0; col<8; col++) {
			tmp = 0;
			for (i=0; i<8; i++)
				tmp += n[row][i] * m[i][col];
			dest[row][col] = tmp;	
		}
	return (long *)dest;
};

	
